    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------------------------
    028     * NormalDistributionFunction2D.java
    029     * ---------------------------------
    030     * (C)opyright 2004, 2005, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: NormalDistributionFunction2D.java,v 1.3.2.2 2005/11/21 10:58:33 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 25-May-2004 : Version 1 (DG);
    040     * 21-Nov-2005 : Added getters for the mean and standard deviation (DG);
    041     *
    042     */
    043
    044    package org.jfree.data.function;
    045
    046    /**
    047     * A normal distribution function.
    048     */
    049    public class NormalDistributionFunction2D implements Function2D {
    050
    051        /** The mean. */
    052        private double mean;
    053
    054        /** The standard deviation. */
    055        private double std;
    056
    057        /**
    058         * Constructs a new normal distribution function.
    059         *
    060         * @param mean  the mean.
    061         * @param std  the standard deviation.
    062         */
    063        public NormalDistributionFunction2D(double mean, double std) {
    064            this.mean = mean;
    065            this.std = std;
    066        }
    067
    068        /**
    069         * Returns the mean for the function.
    070         *
    071         * @return The mean.
    072         */
    073        public double getMean() {
    074            return this.mean;
    075        }
    076
    077        /**
    078         * Returns the standard deviation for the function.
    079         *
    080         * @return The standard deviation.
    081         */
    082        public double getStandardDeviation() {
    083            return this.std;
    084        }
    085
    086        /**
    087         * Returns the function value.
    088         *
    089         * @param x  the x-value.
    090         *
    091         * @return The value.
    092         */
    093        public double getValue(double x) {
    094            return Math.exp(-1.0 * (x - this.mean) * (x - this.mean)
    095                    / (2 * this.std * this.std)) / Math.sqrt(2 * Math.PI
    096                    * this.std * this.std);
    097        }
    098
    099    }